/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.common.sources.models;

import com.asso.ladoxa.datagouv.models.Dataset;
import com.asso.ladoxa.datagouv.models.Organization;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;

import java.time.LocalDateTime;

import java.util.Objects;

/**
 * Scraper resource
 */
@Data
@Builder
@JsonInclude(JsonInclude.Include.NON_NULL)
public class Resource {

    private Source source;

    private Organization organization;

    private Dataset dataset;

    private Object checksum;

    @JsonProperty("created_at")
    private LocalDateTime createdAt;

    private String description;

    private Object extras;

    private Long filesize;


    /**
     * Whether the resource is an uploaded file, a remote file or an API
     */
    public enum FiletypeEnum {
        FILE("file"),

        REMOTE("remote");

        private String value;

        FiletypeEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static FiletypeEnum fromValue(String text) {
            for (FiletypeEnum b : FiletypeEnum.values()) {
                if (String.valueOf(b.value).equals(text)) {
                    return b;
                }
            }
            return null;
        }
    }

    private FiletypeEnum filetype;

    private String format;

    @JsonProperty("remote_id")
    private String remoteId;

    @JsonProperty("last_modified")
    private LocalDateTime lastModified;

    private String latest;

    private Object metrics;

    private String mime;

    private String previewUrl;

    private LocalDateTime published;

    private String title;

    /**
     * Resource type (documentation, API...)
     */
    public enum TypeEnum {
        MAIN("main"),

        DOCUMENTATION("documentation"),

        UPDATE("update"),

        API("api"),

        CODE("code"),

        OTHER("other");

        private String value;

        TypeEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static TypeEnum fromValue(String text) {
            for (TypeEnum b : TypeEnum.values()) {
                if (String.valueOf(b.value).equals(text)) {
                    return b;
                }
            }
            return null;
        }
    }

    private TypeEnum type;

    private String url;

    public Resource checksum(Object checksum) {
        this.checksum = checksum;
        return this;
    }

    public Resource description(String description) {
        this.description = description;
        return this;
    }

    public Resource extras(Object extras) {
        this.extras = extras;
        return this;
    }

    public Resource filesize(Long filesize) {
        this.filesize = filesize;
        return this;
    }

    public Resource filetype(FiletypeEnum filetype) {
        this.filetype = filetype;
        return this;
    }

    public Resource format(String format) {
        this.format = format;
        return this;
    }

    public Resource mime(String mime) {
        this.mime = mime;
        return this;
    }

    public Resource published(LocalDateTime published) {
        this.published = published;
        return this;
    }

    public Resource title(String title) {
        this.title = title;
        return this;
    }

    public Resource type(TypeEnum type) {
        this.type = type;
        return this;
    }

    public Resource url(String url) {
        this.url = url;
        return this;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Resource resource = (Resource) o;
        return Objects.equals(this.checksum, resource.checksum) &&
            Objects.equals(this.createdAt, resource.createdAt) &&
            Objects.equals(this.description, resource.description) &&
            Objects.equals(this.extras, resource.extras) &&
            Objects.equals(this.filesize, resource.filesize) &&
            Objects.equals(this.filetype, resource.filetype) &&
            Objects.equals(this.format, resource.format) &&
            Objects.equals(this.remoteId, resource.remoteId) &&
            Objects.equals(this.lastModified, resource.lastModified) &&
            Objects.equals(this.latest, resource.latest) &&
            Objects.equals(this.metrics, resource.metrics) &&
            Objects.equals(this.mime, resource.mime) &&
            Objects.equals(this.previewUrl, resource.previewUrl) &&
            Objects.equals(this.published, resource.published) &&
            Objects.equals(this.title, resource.title) &&
            Objects.equals(this.type, resource.type) &&
            Objects.equals(this.url, resource.url);
    }

    @Override
    public int hashCode() {
        return Objects.hash(checksum, createdAt, description, extras, filesize, filetype, format, remoteId, lastModified, latest, metrics, mime, previewUrl, published, title, type, url);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Resource {\n");

        sb.append("    checksum: ").append(toIndentedString(checksum)).append("\n");
        sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
        sb.append("    description: ").append(toIndentedString(description)).append("\n");
        sb.append("    extras: ").append(toIndentedString(extras)).append("\n");
        sb.append("    filesize: ").append(toIndentedString(filesize)).append("\n");
        sb.append("    filetype: ").append(toIndentedString(filetype)).append("\n");
        sb.append("    format: ").append(toIndentedString(format)).append("\n");
        sb.append("    remoteId: ").append(toIndentedString(remoteId)).append("\n");
        sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
        sb.append("    latest: ").append(toIndentedString(latest)).append("\n");
        sb.append("    metrics: ").append(toIndentedString(metrics)).append("\n");
        sb.append("    mime: ").append(toIndentedString(mime)).append("\n");
        sb.append("    previewUrl: ").append(toIndentedString(previewUrl)).append("\n");
        sb.append("    published: ").append(toIndentedString(published)).append("\n");
        sb.append("    title: ").append(toIndentedString(title)).append("\n");
        sb.append("    type: ").append(toIndentedString(type)).append("\n");
        sb.append("    url: ").append(toIndentedString(url)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

